#include "Sprite.h"
#include "Chars.h"
#include "VVram.h"
#include "Vram.h"

extern byte[] SpriteChars;

constexpr byte InvalidY = 0xff;
Sprite[SpriteCount] Sprites;

void HideAllSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        p->y = InvalidY;
    }
}


void ShowSprite(ptr<Movable> pMovable, byte code)
{
    ptr<Sprite> p;
    ptr<byte> pSource, pDestination;
    p = Sprites + pMovable->sprite;
    p->x = pMovable->x;
    p->y = pMovable->y;
    
    pSource = SpriteChars + code;
    pDestination = p->bytes;
    repeat(4) {
        *pDestination = *pSource;
        ++pSource;
        ++pDestination;
    }
}


void HideSprite(byte index) 
{
    ptr<Sprite> p;
    p = Sprites + index;
    p->y = InvalidY;
}


void DrawSprites()
{
    ptr<Sprite> p;
    for (p : Sprites) {
        if (p->y != InvalidY) {
            ptr<byte> pVVram, pBytes;
            byte c;
            pVVram = VVramPtr(p->x, p->y);
            pBytes = p->bytes;
            pVVram[0] = *pBytes;
            ++pBytes;
            pVVram[1] = *pBytes;
            if (p->y < VVramHeight - 1) {
                ++pBytes;
                pVVram[VVramWidth] = *pBytes;
                ++pBytes;
                pVVram[VVramWidth + 1] = *pBytes;
            }
        }
    }
}
