include "VVram.inc"
include "Chars.inc"

ext VVram_
ext CellMap_
ext LineRed_
ext SpriteChars_

MapWidth equ VVramWidth/2
MapHeight equ VVramHeight/2

Cell_Wall equ 10h
Cell_Item equ 20h
Cell_Mask equ 0f0h

Line_None equ 0
Line_RightBottom equ 1
Line_LeftBottom equ 2
Line_RightTop equ 3
Line_LeftTop equ 4
Line_Left equ 5
Line_Right equ 6
Line_Top equ 7
Line_Bottom equ 8

cseg
NormalLineChars:
	defb	64h, 44h, 22h, 26h, 04h, 20h, 22h, 44h
RedLineChars:
	defb	0ech, 0cdh, 0b3h, 37h, 05h, 0a0h, 33h, 0cch
LineBytes:
    defb Line_None, Line_None, Line_None, Line_None ; none
    defb Line_Bottom, Line_None, Line_Top, Line_None ; left
    defb Line_None, Line_Bottom, Line_None, Line_Top ; right
    defb Line_Bottom, Line_Bottom, Line_Top, Line_Top ; left right
    defb Line_Right, Line_Left, Line_None, Line_None ; top
    defb Line_RightBottom, Line_Left, Line_Top, Line_None ; top left
    defb Line_Right, Line_LeftBottom, Line_None, Line_Top ; top right
    defb Line_RightBottom, Line_LeftBottom, Line_Top, Line_Top ; top left right
    defb Line_None, Line_None, Line_Right, Line_Left ; bottom
    defb Line_Bottom, Line_None, Line_RightTop, Line_Left ; bottom left
    defb Line_None, Line_Bottom, Line_Right, Line_LeftTop ; bottom right
    defb Line_Bottom, Line_Bottom, Line_RightTop, Line_LeftTop ; bottom left right
    defb Line_Right, Line_Left, Line_Right, Line_Left ; bottom top
    defb Line_RightBottom, Line_Left, Line_RightTop, Line_Left ; bottom top left
    defb Line_Right, Line_LeftBottom, Line_Right, Line_LeftTop ; bottom top right
    defb Line_RightBottom, Line_LeftBottom, Line_RightTop, Line_LeftTop ; bottom top left right

cseg

; ptr<byte> VVramPtr(byte x, byte y);
VVramPtr_: public VVramPtr_
    push de
        ex de,hl
            ld h,0
            add hl,hl ;*2
            add hl,hl ;*4
            add hl,hl ;*8
            add hl,hl ;*16
            add hl,hl ;*32
        ex de,hl
        ld l,a
        ld h,0
        add hl,de
        ld de,VVram_
        add hl,de
    pop de
ret


; void MapToVVram();
cseg

MapToVVram_: public MapToVVram_
    push af | push hl | push de | push bc
        ld hl,VVram_
        ld de,CellMap_
        ld c,MapHeight
        do
            ld b,MapWidth
            do
                push bc
                    ld a,(de) | inc de
                    cp Cell_Wall
                    if z
                        exx
                            ld de,SpriteChars_+Char_Block
                        exx
                        jr byChar
                    endif
                    cp Cell_Item
                    if z
                        exx
                            ld de,SpriteChars_+Char_Item
                        exx
                        byChar:
                        push bc
                            ld c,2
                            do
                                ld b,2
                                do
                                    exx
                                        ld a,(de) | inc de
                                    exx
                                    ld (hl),a | inc hl
                                    inc a
                                dwnz
                                push de
                                    ld de,VVramWidth-2
                                    add hl,de
                                pop de
                                dec c
                            while nz | wend
                        pop bc
                        jr nextCell
                    endif
                    and 0fh
                    add a,a
                    add a,a
                    push de
                        add a,low LineBytes
                        ld e,a
                        ld a,high LineBytes
                        adc a,0
                        ld d,a
                        push bc
                            ld c,2
                            do
                                ld b,2
                                do
                                    ld a,(de) | inc de
                                    push af
                                        cp Line_None
                                        if nz
                                            exx
                                                ld e,a
                                                ld d,0
                                                ld a,(LineRed_)
                                                or a
                                                if nz
                                                    ld hl,NormalLineChars-1
                                                else
                                                    ld hl,RedLineChars-1
                                                endif
                                                add hl,de
                                                ld a,(hl)
                                            exx
                                        endif
                                        ld (hl),a | inc hl
                                    pop af
                                dwnz
                                push de
                                    ld de,VVramWidth-2
                                    add hl,de
                                pop de
                                dec c
                            while nz | wend
                        pop bc
                    pop de
                    nextCell:
                    push de
                        ld de,2-VVramWidth*2
                        add hl,de
                    pop de
                pop bc
            dwnz
            push de
                ld de,VVramWidth
                add hl,de
            pop de
            dec c
        while nz | wend
    pop bc | pop de | pop hl | pop af
ret
